/**============================================================================
 * 
 * This file give necessary functions to design a graphic palette.
 * 
 * Javascript 1.3 and more
 * 
 * LICENSE: This source file is subject to version 2.0 of the CeCILL license
 * that is available through the world-wide-web at the following URI:
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt.  
 * 
 * @category   -
 * @package    -
 * @author     Marc DIAZ <webmaster@cvstandard.net>
 * @copyright  2005-2008 cvstandard.net
 * @licence    CeCILL (GNU GPL compatible) , http://www.cecill.info/
 * @version    1.02
 * @link       -
 * @see        -
 * @since      -
 * @deprecated -
 *
 **============================================================================
 */


/**====================================
 * Global Variables
 **====================================
 */

// Hexadecimal base
var aPal_Hexa = ["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F"];

var oPal_MouseOverColor     = new Object; // Cell changing of color on mouse over
var oPal_MouseOverColorCode = new Object; // Color code on mouse over
var oPal_MouseOverColorCodeHexa = new Object; // HexaDecimal code of the current color
var oPal_MouseClickColor    = new Object; // Div element that change of color on mouse of color
var sPal_PaletteDefault     = 256;      // 256 colors in the fade palette by default
var sPal_RDefault           = 255;      // Red by default
var sPal_GDefault           = 0;        // Green by default
var sPal_BDefault           = 0;        // Blu by default

var iMatrixLen       = 192; // initial = (192)^2 px square
var iRainbowLen      = 256; // initial = 256 px height

var bIE = (document.all)?1:0;
var bNS = (navigator.userAgent.indexOf("Mozilla"))?1:0;
var bGC = (navigator.userAgent.indexOf("Chrome"))?1:0;

// Labels
var sLbl_title            = ""; // not used
var sLbl_BasicFadeElement = "Rainbow base";
var sLbl_Palette          = "Palette";
var sLbl_Color            = "Color";
var sLbl_RGB              = "RGB";
var sLbl_Hexa             = "Hexa.";
var sLbl_colors           = "colors";
var sLbl_rebuild          = "Rebuild";
var sLbl_btOk             = "Ok";
var sLbl_btCancel         = "Back";


/**====================================
 * String Functions
 **====================================
 */

function ltrim( sMainString ) {
	var sMainResult = new String;
	var i = 0;

	while ( sMainString.charAt( i++ ) == " " ) {}
	sMainResult = sMainString.substring( i-1 , sMainString.length ) ;

	return( sMainResult );
}

function rtrim( sMainString ) {
	var i = sMainString.length - 1;
	var sMainResult = new String;

	while( sMainString.charAt( i ) == " " ) i--;
	sMainResult = sMainString.substring( 0 , i+1 );

	return( sMainResult );
}

function trim( sMainString ) {
	var sMainResult = "";
	return( rtrim( ltrim( sMainString ) ) );
}

function left( sMainString , iChar ) {
	return( sMainString.substring( 0 , eval( iChar ) ) );
}

function right( sMainString , iChar ){
	return( sMainString.substring( sMainString.length - eval( iChar ) , sMainString.length ) );
}




//=============================================================================
//                            Palette Functions
//=============================================================================

/*===============================================
	Name   : Palette_FadeOnClick
	Desc   : -
	Input  : -
	Output : -
===========================*/
function Palette_FadeOnClick(){
	var sColorSelected = new String;
	var sColorSelectedHexa = new String;

	// Get the selected color
	sColorSelected = oPal_MouseOverColor.style.background;


	// Display the selectd color in the little box
	oPal_MouseClickColor.style.background = sColorSelected;
	document.getElementById("divSelectedColor").style.background=sColorSelected;

	// Get the code of the selected color
	// + transform the RGB code in Hexa code
	if (!bIE){
	    // rgb(a,b,c) + blablabla added with some browser such as Firefox
	    sColorSelected = left(sColorSelected,sColorSelected.indexOf(")")+1);
    }
	sColorSelectedHexa= right(sColorSelected,sColorSelected.length-4);
	sColorSelectedHexa = (','+left(sColorSelectedHexa,sColorSelectedHexa.length-1)).split(',');

	
	// Display the hexa code of the color
	document.getElementById("divHexa").innerHTML = "#"
		+ aPal_Hexa[  parseInt(sColorSelectedHexa[1]/16) ] + aPal_Hexa[  parseInt(sColorSelectedHexa[1]%16) ]
		+ aPal_Hexa[  parseInt(sColorSelectedHexa[2]/16) ] + aPal_Hexa[  parseInt(sColorSelectedHexa[2]%16) ]
		+ aPal_Hexa[  parseInt(sColorSelectedHexa[3]/16) ] + aPal_Hexa[  parseInt(sColorSelectedHexa[3]%16) ]
	
	// Display the RGB code of the color
	document.getElementById("divRgb").innerHTML = ""
		+ "rgb("
		+ sColorSelectedHexa[1]
		+ ","
		+ sColorSelectedHexa[2]
		+ ","
		+ sColorSelectedHexa[3]
		+ ")"
}



/*===============================================
	Name   : Palette_RainbowOnClick
	Desc   : On click on the rainbow palette,
	         	1 - change of the selected default base color
	         	2 - change of the fade colors matrix
	Input  : -
	Output : -
===========================*/
function Palette_RainbowOnClick(){
	var sColorSelected = new String;
	var sColorSelectedHexa = new String;

	sColorSelected = oPal_MouseOverColor.style.background
	if (!bIE){
	    sColorSelected = left(sColorSelected,sColorSelected.indexOf(")")+1);
    }
	sColorSelectedHexa = right(sColorSelected,sColorSelected.length-4);
	sColorSelectedHexa = (','+left(sColorSelectedHexa,sColorSelectedHexa.length-1)).split(',');
	
	document.frmPalette.sR.value = trim(sColorSelectedHexa[1]);
	document.frmPalette.sG.value = trim(sColorSelectedHexa[2]);
	document.frmPalette.sB.value = trim(sColorSelectedHexa[3]);
	
	Palette_FadeCompute(sColorSelectedHexa[1],sColorSelectedHexa[2],sColorSelectedHexa[3],document.frmPalette.sPal[document.frmPalette.sPal.selectedIndex].value)

}



/*===============================================
	Name   : Palette_FadeOnMouseOver
	Desc   : 
	Input  : oCell : cell of the matrix with the mouse over
	Output : -
===========================*/
function Palette_FadeOnMouseOver(oCell){
	var sColorSelected = new String;
	var sColorSelectedHexa = new String;

	sColorSelected = oCell.style.background
	oPal_MouseOverColor.style.background = sColorSelected;
	if (!bIE){
	    sColorSelected = left(sColorSelected,sColorSelected.indexOf(")")+1);
    }
	sColorSelectedHexa = right(sColorSelected,sColorSelected.length-4);
	sColorSelectedHexa = (','+left(sColorSelectedHexa,sColorSelectedHexa.length-1)).split(',');

	oPal_MouseOverColorCodeHexa.innerHTML = " #"
		+ aPal_Hexa[  parseInt(sColorSelectedHexa[1]/16) ] + aPal_Hexa[  parseInt(sColorSelectedHexa[0]%16) ]
		+ aPal_Hexa[  parseInt(sColorSelectedHexa[2]/16) ] + aPal_Hexa[  parseInt(sColorSelectedHexa[1]%16) ]
		+ aPal_Hexa[  parseInt(sColorSelectedHexa[3]/16) ] + aPal_Hexa[  parseInt(sColorSelectedHexa[2]%16) ]

}



/*===============================================
	Name   : Palette_FadeCompute
	Desc   : Compute the fade matrix
	         1 - of the rainbow
	         2 - of the form
	         The last parameter is the color from the form
	Input  : sR,sG,sB - primary colors
	         iPal - the palette : 256,512,1024,4096 colors
	Output : Integer
===========================*/
function Palette_FadeCompute(sR,sG,sB,iPal){
	var i,j;
	var sRes1 = ""; // Temporary result
	var sRes2 = ""; // Temporary result
	var sRes3 = ""; // Temporary result
	var sSubRes2 = ""; // Temporary result
	
	// Get the parameters
	var sBaseR = sR;
	var sBaseG = sG;
	var sBaseB = sB;
	
	// Compute the palette
	var iPalette = Math.round(Math.sqrt(iPal));
	var iPalette2 =  iPalette*iPalette;

	// ponderation by primary color for each line
	// en fonction du degrade
	var sProd1R = sBaseR/iPalette;
	var sProd1G = sBaseG/iPalette;
	var sProd1B = sBaseB/iPalette;
	
	// ponderation par primary color, used sense is the height
	// en fonction du degrade
	var sProd2R = (255-sBaseR)/iPalette2;
	var sProd2G = (255-sBaseG)/iPalette2;
	var sProd2B = (255-sBaseB)/iPalette2;

	var sProd3R; // Temporary result
	var sProd3G; // Temporary result
	var sProd3B; // Temporary result

	document.getElementById("divFade").innerHTML="Computing..."; // ?? Does it run ??
	
	// The matrix is below
	for (i=0;i<iPalette;i++){
		sSubRes2 = "";
		sProd3R = sProd2R*i;
		sProd3G = sProd2G*i;
		sProd3B = sProd2B*i;
		for (j=0;j<iPalette;j++){
			sSubRes2 += '<td class="palCell" '
				+ 'onmouseover="Palette_FadeOnMouseOver(this)" style="background:rgb('
				+      Math.round(  (sProd1R*j)  +  (j*sProd3R)  )
				+ ','+ Math.round(  (sProd1G*j)  +  (j*sProd3G)  )
				+ ','+ Math.round(  (sProd1B*j)  +  (j*sProd3B)  )
				+ ');"></td>'; 
		}
		sRes2 += '<tr>' + sSubRes2 + '</tr>';
	}
	//sRes1 = "Taille du contenu : "+ sRes2.length +" ("+ iPalette2 +" "+ sLbl_colors +")<br/>";
	sRes1 = '<table onclick="Palette_FadeOnClick()" cellpadding="0" cellspacing="0" border="0" style="width:'+ iMatrixLen +'px;height:'+ iMatrixLen +'px;">';
	sRes3 = "</table>";

	document.getElementById("divFade").innerHTML =  sRes1 + sRes2 + sRes3;
}



/*===============================================
	Name   : Palette_Rainbow
	Desc   : Compute the rainbow palette
	Input  : -
	Output : -
===========================*/
function Palette_Rainbow(){
	var i,j;
	var sRes1 = "";

	var sSubRes1 = "";
	var sSubRes2 = "";

	var iStep = 8; // values : 6=256 px
	var sCol = "";
	
	// Recompute the height of the rainbow
	iRainbowLen = iRainbowLen*6/iStep;

	var aRainbow = new Array;
	aRainbow[0] = "sCol = '255,0,'+j;";
	aRainbow[1] = "sCol = (255-j)+',0,255';";
	aRainbow[2] = "sCol = '0,'+j+',255';";
	aRainbow[3] = "sCol = '0,255,'+(255-j);";
	aRainbow[4] = "sCol = j+',255,0';";
	aRainbow[5] = "sCol = '255,'+(255-j)+',0';";

	// Build the rainbow
	for(i=0;i<6;i++){
		sSubRes2 = "";
		for (j=0;j<256;j+=iStep){
			eval(aRainbow[i]);
			sSubRes2 += '<tr><td class="palCell"'
			 	+ ' onmouseover="Palette_FadeOnMouseOver(this);" '
				+ ' style="background:rgb('
				+   sCol
				+ ');"></td></tr>'; 
		}
		sSubRes1 += sSubRes2;
	}
	
	sRes1 = '<table onclick="Palette_RainbowOnClick()" cellpadding="0" cellspacing="0" border="0" style="width:20px;height:'+ iRainbowLen +'px;">'
		+ sSubRes1
		+ '</table>';
	document.getElementById("divPalRainbow").innerHTML = sRes1;
}




/*===============================================
	Name   : Palette_Draw
	Desc   : -
	Rmak   : The display order is VERY important !
	         The display of the div where is put the color
	         MUST BE displayed BEFORE the display of the palette
	         in order to a fast onMouseOver event
	         Why ? Who knows...
	Input  : -
	Output : -
===========================*/
function Palette_Draw(){

	document.write( ""
		+ '<span class="divTableColor"></span>'
		+ '<span class="divColorMOver" id="divMsOver" name="divMsOver">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>'
		+ '<span class="divColorMClic" id="divMsClick" name="divMsClick">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>'
		+ '<span class="divColorCHexa" id="divMsOverCodeHexa" name="divMsOverCodeHexa">&nbsp;</span><br/>'
		+ '<span class="divColorOverC" id="divMsOverCode" name="divMsOverCode"></span>'
		+ '<span class="divMatrixFade" id="divFade" name="divFade"></span>'
		+ '<span class="divPalRainbow" id="divPalRainbow" name="divPalRainbow"></span>'
		+ '');

	//	+ '<span style="position:absolute;left:180px;top:10px;" id="divMsOverCodeHexa" name="divMsOverCodeHexa" style="text-align:center;border:1px solid;width:60px;"></span><br/>'

	// Display the palette
	Palette_FadeCompute(sPal_RDefault,sPal_GDefault,sPal_BDefault,sPal_PaletteDefault);

	// Get the references of the create objects.
	oPal_MouseOverColor = document.getElementById("divMsOver");
	oPal_MouseOverColorCode = document.getElementById("divMsOverCode");
	oPal_MouseOverColorCodeHexa = document.getElementById("divMsOverCodeHexa");
	oPal_MouseClickColor = document.getElementById("divMsClick");


	// Display the rainbow
	Palette_Rainbow(); 


	document.write( ""
		+'<span name="frmId" id="frmId">'
		+'	<form name="frmPalette">'
		+'	<table border="0" cellpadding="0" cellspacing="0">'
		+'	<tr>'
		+'		<td width="10"></td>'
		+'		<td valign="top"><span name="frmContent" id="frmContent" style="width:190px;">'
		+'              <span class="lbl">'+ sLbl_BasicFadeElement +'</span>'
		+'			<br/>'
		+'			&nbsp;<span class="lblRGB">R</span> <input name="sR" id="sR" class="dataRGB" maxlength="3">'
		+'			&nbsp;<span class="lblRGB">G</span> <input name="sG" id="sG" class="dataRGB" maxlength="3">'
		+'			&nbsp;<span class="lblRGB">B</span> <input name="sB" id="sB" class="dataRGB" maxlength="3">'
		+'			<br/>'
		+'			<br/><span class="lblPalette">'+ sLbl_Palette +'</span>'
		+'			<br/><select name="sPal" class="selectPal" onchange="Palette_FadeCompute(sR.value,sG.value,sB.value,sPal[sPal.selectedIndex].value);"><option value="256" selected >256 '+ sLbl_colors +'</option><option value="512">512 '+ sLbl_colors +'</option><option value="1024">1024 '+ sLbl_colors +'</option><option value="4096">4096 '+ sLbl_colors +'</option></select>'
		+'			<br/>'
		+'		</span></td>'
		+'		<td width="10"></td>'
		+'	</tr>'
		+'	</table>'
		+'	</form>'
		+'</span>'
		+'<span class="divColorSel">'
		+'	<span class="lbl">'+ sLbl_Hexa +' :</span> <span id="divHexa" name="divHexa"></span>'
		+'	<br/><span class="lbl">'+ sLbl_RGB +'  :</span>  <span id="divRgb" name="divRgb"></span>'
		+'	<br/><span class="lbl">'+ sLbl_Color +' :</span> <span id="divSelectedColor" name="divSelectedColor" style="width:50px;height:5px;border:1px solid;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>'
		+'</span>'
		+'<span class="divButtonCancel" onclick="Palette_ButtonCancel()">'+sLbl_btCancel+'</span>'
		+'<span class="divButtonOk" onclick="Palette_ButtonOk()">'+sLbl_btOk+'</span>'
		+ '');
    /*
		+'			<br/><input type="button" value="'+ sLbl_rebuild +'" onclick="'
		+'				Palette_FadeCompute(sR.value,sG.value,sB.value,sPal[sPal.selectedIndex].value);'
		+'				">'
    */
	this.document.getElementById("sR").value=sPal_RDefault;
	this.document.getElementById("sG").value=sPal_GDefault;
	this.document.getElementById("sB").value=sPal_BDefault;
	
	document.body.style.fontFamily = "Arial";
	document.body.style.fontSize = "10pt";
	document.getElementById("frmContent").style.fontFamily = "Arial";
	document.getElementById("frmContent").style.fontSize = "10pt";
	
}




/*===============================================
	Name   : Palette_ButtonCancel,Palette_ButtonOk
	Desc   : Clic on Ok (V) ou Cancel (X) buttons
	Input  : -
	Output : ButtonOk record in "sPalette_SelectedColorRgb" and
	         "sPalette_SelectedColorHexa" the Rgb & Hexadecimale values
	         of the selected color
===========================*/

function Palette_ButtonCancel(){
	window.close();
}

function Palette_ButtonOk(){
	if (window.opener){
		window.opener.sPalette_SelectedColorRgb = document.getElementById("divRgb").innerHTML;
		window.opener.sPalette_SelectedColorHexa = document.getElementById("divHexa").innerHTML;
	}
	window.close();
}



/*===============================================
	Name   : Palette_OnLoad
	Desc   : Reinitialization of "sPalette_SelectedColorRgb" &
	         "sPalette_SelectedColorHexa"
	Input  : -
	Output : -
===========================*/
function Palette_OnLoad(){
	if (window.opener){
		window.opener.sPalette_SelectedColorRgb = "";
		window.opener.sPalette_SelectedColorHexa = "";
	}
}
